//+------------------------------------------------------------------+
//|                                         radu.hu-poziciozaras.mq4 |
//|                                           Copyright  2013, Radu |
//|                                              http://www.radu.hu/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Radu"
#property link      "http://www.radu.hu/"

#define SET_POS_CLOSE_RETRY 15

#include <stderror.mqh>

int start() {

   int
      m = 0,
      poziciok[],
      elemszam;

   ArrayResize(poziciok, 0);
   // a tmb elemeinek nullra lltsa

   // pozcik vgignylazsa
   for (int k = 0; k < OrdersTotal(); k++) {

      // pozci index alap kivlasztsa
      if (OrderSelect(k, SELECT_BY_POS)) {

         // csak azon pozcik, amelyek azonosak az aktulis instrumentummal
         if (OrderSymbol() == Symbol()) {

            // tmb elemei szmnak rgztse
            m = ArraySize(poziciok);

            // tmb tmretezse eggyel nagyobb elemszmra
            ArrayResize(poziciok, m + 1);

            // az j elemszm (teljes mret - 1) feltltse a tickettel
            poziciok[m] = OrderTicket();
         }
      }
   }

   // tmb elemei szmnak rgztse
   elemszam = ArraySize(poziciok);

   Print ("A tmb elemszma = ", elemszam);

   // vgigmegynk a tmb adatain
   for (k = 0; k < elemszam; k++) {
  
      // zrs a ticket szm alapjn
      PozicioZaro(poziciok[k]);
   }

   return (0);
}

// pozcizr fggvny
bool PozicioZaro (int ticket) {
   
   bool  
      // alap esetben a fggvny vgeredmnynek rtke: hamis
      result = false,
            
      // alap esetben a zrst megprbljuk
      closing = true;

   // ticket szm ellenrzse; amennyiben nulla 
   // vagy annl kisebb, nem megynk tovbb
   if (ticket > 0) {

      int
         // max. elfogadott csszs market maker brker esetn (pontban)
         Slippage = 3,

         // esetleges hibakdot tartalmaz vltoz
         Error,

         // hiba esetn vrakozs (millisec)
         SleepTime = 300,

         // prblkozsok szma
         v = 0
         ;

      // pozci kivlasztsa; tovbbhalads, ha sikeres
      if (OrderSelect(ticket, SELECT_BY_TICKET)) {

         // while ciklus a hibs prblkozsokra kszlve
         while (v <= SET_POS_CLOSE_RETRY) {
         

            // nyitva van mg a pozci?
            if (OrderCloseTime() == 0) {

               // hiba vltoz nullzsa
               Error = 0;

               // frisstjk a bels adatokat (rak, gyertyk, stb.)
               RefreshRates();

               double
                   // pozci instrumentuma alapjn a freeze level lekrdezse
                  FreezeLevel = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL) * MarketInfo(OrderSymbol(), MODE_POINT),
                  PRICE;

               // switch szerkezet a pozci tpushoz szksges tevkenysgekhez
               switch (OrderType()) {

                  case OP_BUY:

                     // az instrumentum BID rnak lekrdezse
                     PRICE = MarketInfo(OrderSymbol(), MODE_BID);

                     // amennyiben van takeprofit, ellenrizzk a klnbsget
                     if (OrderTakeProfit() > 0 && OrderTakeProfit() - PRICE <= FreezeLevel) {
                        closing = false;
                     }

                     // amennyiben van stoploss, ellenrizzk a klnbsget
                     if (OrderStopLoss() > 0 && PRICE - OrderStopLoss() <= FreezeLevel) {
                        closing = false;
                     }

                  break;

                  case OP_SELL:

                     // az instrumentum ASK rnak lekrdezse

                     PRICE = MarketInfo(OrderSymbol(), MODE_ASK);

                     // tennival: fagysi szint ellenrzse

                  break;

                  case OP_BUYLIMIT:

                     // tennival: fagysi szint ellenrzse

                  break;

                  case OP_BUYSTOP:

                     // tennival: fagysi szint ellenrzse

                  break;

                  case OP_SELLSTOP:

                     // tennival: fagysi szint ellenrzse

                  break;

                  case OP_SELLLIMIT:

                     // tennival: fagysi szint ellenrzse
 
                  break;
               }
               
               // amennyiben nem futottunk bele valami tiltsba, megprbljuk a zrst
               if (closing) {

                  switch (OrderType()) {

                     case OP_BUY:
                     case OP_SELL:

                        if (OrderClose(ticket, OrderLots(), PRICE, Slippage)) {

                           Print (StringConcatenate("#", ticket, " pozci zrsa sikeres!"));
                           result = true;
                        }
                        else {
                           Error = GetLastError();

                           Print (StringConcatenate("#", ticket, " pozci zrsa sikertelen; hibakd = ", Error));
                        }

                     break;

                     case OP_BUYLIMIT:
                     case OP_BUYSTOP:
                     case OP_SELLSTOP:
                     case OP_SELLLIMIT:

                        // a fgg megbzsokat csak trlni kell
                        if (OrderDelete(ticket)) {

                           Print (StringConcatenate("#", ticket, " pozci zrsa sikeres!"));
                           result = true;
                        }
                        else {
                           Error = GetLastError();

                           Print (StringConcatenate("#", ticket, " pozci zrsa sikertelen; hibakd = ", Error));
                        }

                     break;
                  }
               }
               else {

                  Print (StringConcatenate("#", ticket, " pozcit nem zrjuk, mert a fagysi szinthez tl kzel van az r!"));

                  break;
               }
            }
            else {
               Print ("A #", OrderTicket(), " pozci mr lezrult!");
               break;
            }

            if (result) {
               // sikeres zrs esetn megszaktjuk a ciklust
               break;
            }

            // foglalt trade context esetn folytatjuk a ciklust, a prblkozsi szm emelse nlkl
            if (Error == ERR_TRADE_CONTEXT_BUSY || Error == ERR_SERVER_BUSY || Error == ERR_BROKER_BUSY) {
               Print (StringConcatenate("A trade context foglalt ekkor: ", TimeToStr(TimeCurrent(), TIME_SECONDS), "; vrakozs..."));
               Sleep (SleepTime);
               continue;
            }

            // Slyos hibk valamelyike => azonnali megszakts
            if ((
            Error >= ERR_TRADE_NOT_ALLOWED && Error <= ERR_SHORTS_NOT_ALLOWED) || Error == ERR_INVALID_TRADE_PARAMETERS || 
            Error == ERR_TRADE_EXPIRATION_DENIED || Error == ERR_MARKET_CLOSED || Error == ERR_ACCOUNT_DISABLED || 
            Error == ERR_INVALID_ACCOUNT || Error == ERR_INVALID_TRADE_VOLUME || Error == ERR_NO_CONNECTION ||
            Error == ERR_TRADE_TOO_MANY_ORDERS || Error == ERR_TRADE_PROHIBITED_BY_FIFO || Error == ERR_INVALID_TICKET) {
      
               break; 
            }

            v++;
         }
      }
      else {
         Print ("Nem tudom kivlasztani ezt a pozcit: #", ticket);
      }
   }
   
   // vgeredmny visszaadsa
   return (result);
}

/*

      
   Print ("A tmb elemszma = ", ArraySize(poziciok));
   // eredmny: A tmb elemszma = 0
   
   ArrayResize(poziciok, 1);
   // tmretezs 1 elem tmbb
   
   poziciok[0] = 2013;
   // az egyetlen, nulls index elembe beszrunk egy rtket
   
   Print ("A tmb elemszma = ", ArraySize(poziciok));
   // eredmny: A tmb elemszma = 1
   
   Print ("A nulls index rtke = ", poziciok[0]);
   // eredmny: A nulls index rtke = 2013
   
   ArrayResize(poziciok, 2);
   // tmretezs 2 elem tmbb
   
   poziciok[1] = 2014;
   // a msodik index (1) elemet feltltjk adattal
   
   Print ("A tmb elemszma = ", ArraySize(poziciok));
   // eredmny: A tmb elemszma = 2
   
   Print ("A nulls index rtke = ", poziciok[0], ", a msodik adat pedig = ", poziciok[1]);
   // eredmny: A nulls index rtke = 2013, a msodik adat pedig = 2014

   ArrayResize(poziciok, 1);
   // kisebbre zsugortjuk a tmbnket...
   
   Print (poziciok[1]);
   // ...gy elvesztjuk a korbbi adatunkat (2014)
   
   ArrayResize(poziciok, 2);
   // jra kettre nveljk az elemszmot...
   
   Print (poziciok[1]);
   // ...az adatunk viszont nincs meg, alap rtkknt nullt kapunk vissza.
   

   return(0);
*/



